package lu.tudor.santec.dicom.anonymizer;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.JTextField;

import lu.tudor.santec.dicom.gui.header.DicomHeader;

import org.dcm4che2.util.StringUtils;

import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

public class SimpleAnonPanel extends JPanel {

    private static final long serialVersionUID = 1L;
    private JCheckBox removePatientCB;
    private JTextField newPatientID;
    private JCheckBox removeInstitutionCB;
    private JTextField newInstitutionName;
    private JCheckBox removeManufacturerCB;
    private JTextField newPatientName;

    public SimpleAnonPanel() {
    
    CellConstraints cc = new CellConstraints();
	this.setLayout(new FormLayout(
		"3dlu, pref, 3dlu, pref:grow, 3dlu",
		"3dlu, pref, 3dlu, pref, 3dlu, pref, 3dlu, pref, 3dlu, pref, 3dlu, pref, 3dlu, pref, 3dlu, pref, 3dlu, pref, 3dlu, fill:pref:grow, 3dlu"
	));
	this.setOpaque(false);
	
	removePatientCB = new JCheckBox("remove Patient Information", true);
	removePatientCB.setToolTipText(createInfo(DicomAnonymizer.PATIENT_TAGS));
	removePatientCB.setOpaque(false);
	this.add(removePatientCB, cc.xyw(2,2,3));
	removePatientCB.addActionListener(new ActionListener(){
	    public void actionPerformed(ActionEvent e) {
		    newPatientID.setEnabled(removePatientCB.isSelected());
		    newPatientName.setEnabled(removePatientCB.isSelected());
	    }
	});
	this.add(new JLabel("Patient ID"), cc.xyw(2,4,1));
	newPatientID = new JTextField(System.currentTimeMillis()+"");
	this.add(newPatientID, cc.xyw(4,4,1));
	this.add(new JLabel("Patient Name"), cc.xyw(2,6,1));
	newPatientName = new JTextField("ANONYMOUS");
	this.add(newPatientName, cc.xyw(4,6,1));
	this.add(new JSeparator(), cc.xyw(2,8,3));
	
	removeInstitutionCB = new JCheckBox("remove Institution Information", true);
	removeInstitutionCB.setToolTipText(createInfo(DicomAnonymizer.INSTITUTION_TAGS));
	removeInstitutionCB.setOpaque(false);
	this.add(removeInstitutionCB, cc.xyw(2,10,3));
	removeInstitutionCB.addActionListener(new ActionListener(){
	    public void actionPerformed(ActionEvent e) {
		    newInstitutionName.setEnabled(removeInstitutionCB.isSelected());
	    }
	});
	this.add(new JLabel("Institution Name"), cc.xyw(2,12,1));
	newInstitutionName = new JTextField();
	this.add(newInstitutionName, cc.xyw(4,12,1));
	this.add(new JSeparator(), cc.xyw(2,14,3));
	
	removeManufacturerCB = new JCheckBox("remove Manufacturer Information", true);
	removeManufacturerCB.setToolTipText(createInfo(DicomAnonymizer.MANUFACTURER_TAGS));
	removeManufacturerCB.setOpaque(false);
	this.add(removeManufacturerCB, cc.xyw(2,16,3));
	
	this.add(new JSeparator(), cc.xyw(2,18,3));

    }
    
    private String createInfo(int[] tags) {
	StringBuffer sb = new StringBuffer("<html>");
	for (int tag : tags) {
	    sb.append(DicomHeader.getHeaderName(
		    StringUtils.shortToHex(tag >> 16) + 	',' + 
		    StringUtils.shortToHex(tag)));
	    sb.append("<br>");
	}
	return sb.toString();
    }

    public boolean isRemovePatient() {
	return removePatientCB.isSelected();
    }

    public boolean isRemoveInstitution() {
	return removeInstitutionCB.isSelected();
    }

    public boolean isRemoveManufacturer() {
	return removeManufacturerCB.isSelected();
    }

    public String getNewPatientID() {
	return newPatientID.getText();
    }

    public String getNewPatientName() {
	return newPatientName.getText();
    }

    public String getNewInstitutionName() {
	return newInstitutionName.getText();
    }

    public void setRemovePatient(boolean b) {
	this.removePatientCB.setSelected(b);
    }
    
    public void setRemoveInstitution(boolean b) {
	this.removeInstitutionCB.setSelected(b);
    }

    public void setRemoveManufacturer(boolean b) {
	this.removeManufacturerCB.setSelected(b);
    }
    
}
